-- enl.lua

require 'nscr'

module('enl', package.seeall)

function parse(str)
  return nscr.parse(str:gsub("([^ \t]*)<%%(.-)%%>([\r\n]*)", function(script, emb, crlf)
    if emb:sub(1, 1) == "=" then
      -- Luaf[^擾
      -- nscr.executë̓eƂȂB
      local head = "`"
      local tail = "..'`" .. crlf
      -- XNvgɖߍ܂ꂽꍇ
      if #script > 0 and not script:match("[\r\n]+") then
        head = script .. "`'.."
        return head .. emb:gsub("= *(.+)", "%1"):gsub(" +$", "") .. tail
      -- XNvgȂꍇ͋ɎsB
      else
        -- s󕶎Ȃ̂ŁAsȂB
        return script .. [[`nscr.execute(]] .. emb:gsub("= *(.+)", "%1"):gsub(" +$", "") .. [[)`]] .. crlf
      end
    elseif #emb > 1 and emb:sub(1, 2) == "--" then
      -- Rg
      -- B
      return ""
    else
      local tail = "`" .. crlf
      -- sł͂Ȃꍇ
      if #crlf == 0 then tail = ";`" end
      -- Luaڎs
      -- ̂܂܎sB
      return script .. emb:gsub(" *(.+)", "`%1"):gsub(" +$", "") .. tail
    end
  end))
end


function eval(str)
  -- loadstring()ł́AGXP[vLN^lĂȂ2dɂB
  assert(loadstring(parse(str):gsub("\\", "\\\\")))()
end


function load(filename)
  local org = NSGetStrValue(0)
  NSExec('readfile $0,"' .. filename .. '"')
  local text = NSGetStrValue(0)
  NSSetStrValue(0, org)
  eval(text)
end
