NSExec("luasub unittest")
NL_dofile("nscr.lua")
NL_dofile("string.lua")
NL_dofile("enl.lua")

function NSCOM_unittest()
  require "lunit"
  lunit.main({"--runner", "lunit-nscripter", "enl_test.lua", "nscr_test.lua", "string_test.lua"})
end

-- for nscr_test
NSExec('numalias ALIAS_INT,100')
NSExec('stralias ALIAS_STR,"hoge"')

NSExec('luasub test_pop_args')
function NSCOM_test_pop_args()
  local pat = nscr.pop_arg("s")
  args = {nscr.pop_args(pat)}
end

NSExec('luasub test_exec')
function NSCOM_test_exec()
  nscr.execute('puttext "executed"')
end

local text = ""
NSExec('luasub puttext')
function NSCOM_puttext()
  if text ~= "" then text = text .. "\n" end
  text = text .. NSPopStr()
end

function gettext()
  return text
end

function textclear()
  text = ""
end
